using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Thirdparty.CustomerCategory.Cqrs;

public class GetCustomerCategoryByIdResponse
{
    public string? Id { get; set; }
    public string? Name { get; set; }
    public string? Description { get; set; }
    public DateTimeOffset? CreatedAt { get; set; }
    public string? CreatedBy { get; set; }
    public DateTimeOffset? UpdatedAt { get; set; }
    public string? UpdatedBy { get; set; }
}

public record GetCustomerCategoryByIdQuery(string Id) : IRequest<GetCustomerCategoryByIdResponse?>;

public class GetCustomerCategoryByIdHandler : IRequestHandler<GetCustomerCategoryByIdQuery, GetCustomerCategoryByIdResponse?>
{
    private readonly AppDbContext _context;

    public GetCustomerCategoryByIdHandler(AppDbContext context) => _context = context;

    public async Task<GetCustomerCategoryByIdResponse?> Handle(GetCustomerCategoryByIdQuery request, CancellationToken cancellationToken)
    {
        return await _context.CustomerCategory
            .AsNoTracking()
            .Where(x => x.Id == request.Id)
            .Select(x => new GetCustomerCategoryByIdResponse
            {
                Id = x.Id,
                Name = x.Name,
                Description = x.Description,
                CreatedAt = x.CreatedAt,
                CreatedBy = x.CreatedBy,
                UpdatedAt = x.UpdatedAt,
                UpdatedBy = x.UpdatedBy,
            })
            .FirstOrDefaultAsync(cancellationToken);
    }
}